<template>
  <div>
    <div class="row q-pa-md justify-between">
      <div class="row">
        <div class="exam-btn exam-btn-white row">
          <div class="exam-btn-icon">
            <img src="../../public/module.svg" alt="" />
          </div>
          <div class="exam-btn-label" @click="moduelBtn()">Module</div>
        </div>
        <div style="width: 15px"></div>
        <div class="exam-btn exam-btn-blue row">
          <div class="exam-btn-icon">
            <img src="../../public/exam_white.svg" alt="" />
          </div>
          <div class="exam-btn-label">Exam</div>
        </div>
      </div>
      <div class="exam-btn-module row">
        <div class="exam-btn-label" @click="addQuestionBtn()">
          + Add question
        </div>
      </div>
    </div>
    <div class="q-pa-md">
      <div v-for="(item, index) in moduleOptions" :key="index">
        <div class="text-h6 q-py-md">{{ item.label }}</div>
        <div v-for="(item2, index2) in questionShow(item.value)" :key="index2">
          <div class="row">
            <div class="col">
              <div class="q-pb-sm font18">
                {{ index2 + 1 }}. {{ item2.question }}
              </div>

              <div>
                <span :class="[item2.correctanswer == 1 ? 'correctAnswer' : '']"
                  >a. <span v-html="item2.choice1"></span
                ></span>
              </div>
              <div>
                <span :class="[item2.correctanswer == 2 ? 'correctAnswer' : '']"
                  >b. <span v-html="item2.choice2"></span
                ></span>
              </div>
              <div v-if="item2.choice3.length > 0">
                <span :class="[item2.correctanswer == 3 ? 'correctAnswer' : '']"
                  >c. <span v-html="item2.choice3"></span
                ></span>
              </div>
              <div v-if="item2.choice4.length > 0">
                <span :class="[item2.correctanswer == 4 ? 'correctAnswer' : '']"
                  >d. <span v-html="item2.choice4"></span
                ></span>
              </div>
            </div>
            <div style="width: 80px">
              <span class="linkShow" @click="editQuestion(item2.id)">edit</span>
            </div>
            <div style="width: 80px">
              <span
                class="linkShow"
                @click="deleteQuestion(item2.id, item.value)"
                >delete</span
              >
            </div>
          </div>
          <div class="linehr"></div>
        </div>
      </div>
    </div>

    <!-- Add dialog -->
    <q-dialog v-model="addQuestionDialog">
      <q-card class="user-dialog q-pa-md">
        <div class="text-h6">Add question</div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Module</div>
          <div class="col">
            <q-select
              v-model="input.moduleid"
              outlined
              dense
              :options="moduleOptions"
              emit-value
              map-options
            />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">question</div>
          <div class="col">
            <q-input v-model="input.question" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #1</div>
          <div class="col">
            <q-input v-model="input.choice1" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #2</div>
          <div class="col">
            <q-input v-model="input.choice2" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #3</div>
          <div class="col">
            <q-input v-model="input.choice3" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #4</div>
          <div class="col">
            <q-input v-model="input.choice4" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">correct answer</div>
          <div class="col">
            <q-select
              v-model="input.correctanswer"
              :options="correctAnswerOptions"
              outlined
              dense
              style="width: 100px"
            />
          </div>
        </div>

        <div class="row q-pt-md justify-center">
          <div>
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeAddQuestionDialog()"
            />
          </div>
          <div style="width: 15px"></div>
          <div>
            <q-btn
              label="Save"
              class="short-btn active-btn"
              @click="saveAddQuestion()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- Editdialog -->
    <q-dialog v-model="editQuestionDialog">
      <q-card class="user-dialog q-pa-md">
        <div class="text-h6">Edit question</div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Module</div>
          <div class="col">
            <q-select
              v-model="input.moduleid"
              outlined
              dense
              :options="moduleOptions"
              emit-value
              map-options
            />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">question</div>
          <div class="col">
            <q-input v-model="input.question" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #1</div>
          <div class="col">
            <q-input v-model="input.choice1" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #2</div>
          <div class="col">
            <q-input v-model="input.choice2" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #3</div>
          <div class="col">
            <q-input v-model="input.choice3" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">choice #4</div>
          <div class="col">
            <q-input v-model="input.choice4" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">correct answer</div>
          <div class="col">
            <q-select
              v-model="input.correctanswer"
              :options="correctAnswerOptions"
              outlined
              dense
              style="width: 100px"
            />
          </div>
        </div>

        <div class="row q-pt-md justify-center">
          <div>
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeEditQuestionDialog()"
            />
          </div>
          <div style="width: 15px"></div>
          <div>
            <q-btn
              label="Save"
              class="short-btn active-btn"
              @click="saveEditQuestion()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- alert delete dialog  -->
    <q-dialog v-model="delQuestionDialog" persistent>
      <q-card>
        <q-card-section>
          <div class="titleDialog">Delete question</div>

          <hr style="width: 400px" />
          <div align="center">
            <div>Do you want to delete this question?</div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeQuestionDia()"
            />

            <div style="width: 15px"></div>
            <q-btn
              label="Yes"
              class="short-btn active-btn"
              @click="confirmQuestionBtn()"
            />
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      addQuestionDialog: false,
      editQuestionDialog: false,
      delQuestionDialog: false,
      delID: "",
      moduleID: "",
      input: {
        id: 0,
        moduleid: "",
        question: "",
        choice1: "",
        choice2: "",
        choice3: "",
        choice4: "",
        correctanswer: 1,
      },
      questionData: [],
      moduleOptions: [],
      correctAnswerOptions: [1, 2, 3, 4],
    };
  },
  methods: {
    async confirmQuestionBtn() {
      let dataSend = {
        id: this.delID,
        mid: this.moduleID,
      };
      let url = this.serverpath + "deletequestion.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "finish") {
        this.greenNotify("delete complete");
        this.loadQuestion();
      } else {
        this.redNotify("delete incomplete");
      }
      this.delQuestionDialog = false;
    },
    closeQuestionDia() {
      this.delQuestionDialog = false;
    },
    deleteQuestion(id, mid) {
      this.delID = id;
      this.moduleID = mid;
      this.delQuestionDialog = true;
    },
    async saveEditQuestion() {
      if (
        this.input.question.length > 0 &&
        this.input.choice1.length > 0 &&
        this.input.choice2.length > 0
      ) {
        let url = this.serverpath + "editquestion.php";
        let res = await axios.post(url, JSON.stringify(this.input));
        if (res.data == "finish") {
          this.greenNotify("save complete");
        } else {
          this.redNotify("save incomplete");
        }

        this.editQuestionDialog = false;
      } else {
        this.redNotify("Please input question / choice #1 / choice#2");
      }
    },
    closeEditQuestionDialog() {
      this.loadQuestion();
      this.editQuestionDialog = false;
    },
    editQuestion(id) {
      this.input = this.questionData.filter((x) => x.id == id)[0];
      this.editQuestionDialog = true;
    },
    questionShow(moduleid) {
      return this.questionData.filter((x) => x.moduleid == moduleid);
    },
    async saveAddQuestion() {
      if (
        this.input.question.length > 0 &&
        this.input.choice1.length > 0 &&
        this.input.choice2.length > 0
      ) {
        let url = this.serverpath + "addnewquestion.php";
        let res = await axios.post(url, JSON.stringify(this.input));
        if (res.data == "finish") {
          this.greenNotify("save complete");
        } else {
          this.redNotify("save incomplete");
        }
        this.loadQuestion();
        this.addQuestionDialog = false;
      } else {
        this.redNotify("Please input question / choice #1 / choice#2");
      }
    },
    closeAddQuestionDialog() {
      this.addQuestionDialog = false;
    },
    addQuestionBtn() {
      this.input.moduleid = this.moduleOptions[0].value;
      this.input.question = "";
      this.input.choice1 = "";
      this.input.choice2 = "";
      this.input.choice3 = "";
      this.input.choice4 = "";
      this.input.correctanswer = 1;
      this.addQuestionDialog = true;
    },
    moduelBtn() {
      this.$emit("moduleBtn");
    },
    async loadQuestion() {
      let url = this.serverpath + "loadquestion.php";
      let res = await axios.get(url);
      this.questionData = res.data;
    },
    async loadModule() {
      let key = this.$q.localStorage.getItem("key");
      let dataSend = { key: key };
      let url = this.serverpath + "loadmodule.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "go to examinee") {
        this.$router.push("/examinee");
      } else if (res.data == "go to login") {
        this.$q.localStorage.clear();
        this.$router.push("/");
      } else {
        res.data.forEach((item) => {
          let temp = {
            value: item.id,
            label: item.name,
          };
          this.moduleOptions.push(temp);
        });
        this.input.moduleid = this.moduleOptions[0].value;
      }
    },
  },
  mounted() {
    this.loadModule();
    this.loadQuestion();
  },
};
</script>

<style lang="scss" scoped>
.exam-btn {
  width: 120px;
  height: 40px;
  border-radius: 5px;
  font-size: 18px;
}
.exam-btn-blue {
  background-color: #41aaf2;
  color: white;
}
.exam-btn-icon {
  padding-top: 5px;
  padding-left: 10px;
}
.exam-btn-label {
  padding-top: 6px;
  padding-left: 10px;
}
.exam-btn-white {
  border: 1px solid #4f4f4f;
  cursor: pointer;
}
.exam-btn-module {
  width: 140px;
  height: 40px;
  border-radius: 5px;
  font-size: 18px;
  border: 1px solid #4f4f4f;
  cursor: pointer;
}

.user-dialog {
  min-width: 1100px;
  height: 520px;
}
.user-add-label {
  width: 120px;
  padding-top: 10px;
}
.correctAnswer {
  background-color: rgba(65, 170, 242, 0.25);
}
.linehr {
  width: 100%;
  margin-top: 8px;
  margin-bottom: 8px;
  border-top: 0.2px solid #4f4f4f;
}
.linkShow {
  text-decoration: underline;
  cursor: pointer;
}
</style>
